//
// xitalkbiff.cc
//


#include "socket-stream.h"
#include "misc.h"
#include <X11/IntrinsicP.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <ctype.h>

#include <pwd.h>


struct handle_and_user_id
{
  char *UserID;
  char *Handle;
}HandleAndUserId[]={
{"g440614", "Ϥʤ"},
{"g440604", "GANA"},
{"g440602", "Sumii"},
{"g440611", "Nishi"},
{"g441030", "k_o_"},
{"g441036", "Sigma"},
{"g441232", "SHIGE"},
{"g441200", ""},
{"g440056", "NAO"},
{"g440878", "٣"},
{"g440524", "  (TSGer)"},
{"g540001", ""},
{"g540826", "  (TSGer)"},
{"g540828", "Ҳ  (TSGer)"},
{"g540879", "錄"},
{"g540481", ""},
{"g541119", ""},
{"g541174", " ľ (TSGer)"},
{"g540742", " § (TSGer)"},
{"g541277", "ε (TSGer)"},
{"g540848", "¼  (TSGer)"},
{"g540402", " (TSGer)"},
{"g540752", "Ϥ"},
{"g540307", "ڣţң"},
{"g541290", ""},
{"g541292", "¼  (TSGer)"},
{"l44216", "ã٣"},
{"c41212", "Ϥ"},
{"t50451", ""},
{"t50941", "ԣң"},
{"t50311", "Ȭų"},
{"t50942", "Applause"},
{"s51033", "գͣ"},
{"s31016", ""},
{"ss46280", "Tellur"},
{"ss46002", "ꤹ"},
{"yuki", "ꤹ"},
{"ss56020", "ä"},
{"taka", "ä"},
{"t40571", "Makken"},
{"e54060", "¸"},
{"nayuta", "GANA%home"},
};


char *GetMyName(void)
{
  passwd *pw;
  pw=getpwuid(getuid());
  
  for (int i=0; i<sizeof(HandleAndUserId)/sizeof(handle_and_user_id); i++)
  {
    if (0==strcmp(pw->pw_name, HandleAndUserId[i].UserID))
      return HandleAndUserId[i].Handle;
  }
  return NULL;
}


static String default_resources[]=
{
  "*Title: XItalkBiff",
  "*star: Yellow",
  NULL,
};


static XrmOptionDescRec options[]=
{
{"--help",   ".help",          XrmoptionNoArg,  (XPointer)"True"},
{"-help",    ".help",          XrmoptionNoArg,  (XPointer)"True"},
{"-h",       ".help",          XrmoptionNoArg,  (XPointer)"True"},
{"-l",       ".landscape",     XrmoptionNoArg,  (XPointer)"True"},
{"-nl",      ".landscape",     XrmoptionNoArg,  (XPointer)"False"},
{"-i",       ".italkPipe",     XrmoptionSepArg, (XPointer)NULL},
{"-fn8",     ".font",          XrmoptionSepArg, (XPointer)NULL},
{"-fnAscii", ".font",          XrmoptionSepArg, (XPointer)NULL},
{"-fn16",    ".kanjiFont",     XrmoptionSepArg, (XPointer)NULL},
{"-fk",      ".kanjiFont",     XrmoptionSepArg, (XPointer)NULL},
{"-fnKanji", ".kanjiFont",     XrmoptionSepArg, (XPointer)NULL},
{"-fr",      ".romanKanaFont", XrmoptionSepArg, (XPointer)NULL},
{"-fnKana",  ".romanKanaFont", XrmoptionSepArg, (XPointer)NULL},
{"-star",    ".star",          XrmoptionSepArg, (XPointer)NULL},
{"-fg2",     ".foreground2",   XrmoptionSepArg, (XPointer)NULL},
{"-bg2",     ".background2",   XrmoptionSepArg, (XPointer)NULL},
{"-p",       ".popup",         XrmoptionNoArg,  (XPointer)"True"},
{"-np",      ".popup",         XrmoptionNoArg,  (XPointer)"False"},
{"-pt",      ".popupTime",     XrmoptionSepArg, (XPointer)NULL},
{"-n",       ".showNumber",    XrmoptionNoArg,  (XPointer)"True"},
{"-nn",      ".showNumber",    XrmoptionNoArg,  (XPointer)"False"},
{"-b",       ".beep",          XrmoptionNoArg,  (XPointer)"True"},
{"-nb",      ".beep",          XrmoptionNoArg,  (XPointer)"False"},
};


static struct AppData
{
  String italkpipe;
  String fontAscii;
  String fontKanji;
  String fontKana;
  String foreground;
  String foreground2;
  String star;
  String background;
  String background2;
  Bool   help;
  Bool   landscape;
  Bool   popup;
  int    popup_time;
  Bool   show_number;
  Bool   beep;
}app_data;


static XtResource resources[]=
{
{ "italkPipe",    "ItalkPipe",     XtRString,  sizeof(String),  XtOffset(AppData*, italkpipe),   XtRString,    (XtPointer)"ecc-as50.komaba.ecc.u-tokyo.ac.jp:12344"},
{ "font",         "Font",          XtRString,  sizeof(String),  XtOffset(AppData*, fontAscii),   XtRString,    (XtPointer)"-adobe-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*"},
{ "romanKanaFont","RomanKanaFont", XtRString,  sizeof(String),  XtOffset(AppData*, fontKana),    XtRString,    (XtPointer)"-misc-*-jisx0201.1976-*"},
{ "kanjiFont",    "KanjiFont",     XtRString,  sizeof(String),  XtOffset(AppData*, fontKanji),   XtRString,    (XtPointer)"k14"},
{ "foreground",   "Foreground",    XtRString,  sizeof(String),  XtOffset(AppData*, foreground),  XtRString,    (XtPointer)"White"},
{ "foreground2",  "Foreground",    XtRString,  sizeof(String),  XtOffset(AppData*, foreground2), XtRString,    (XtPointer)"White"},
{ "star",         "Foreground",    XtRString,  sizeof(String),  XtOffset(AppData*, star),        XtRString,    (XtPointer)"Yellow"},
{ "background",   "Background",    XtRString,  sizeof(String),  XtOffset(AppData*, background),  XtRString,    (XtPointer)"gray50"},
{ "background2",  "Background",    XtRString,  sizeof(String),  XtOffset(AppData*, background2), XtRString,    (XtPointer)"gray40"},
{ "help",         "Help",          XtRBoolean, sizeof(Boolean), XtOffset(AppData*, help),        XtRImmediate, (XtPointer)False},
{ "landscape",    "Landscape",     XtRBoolean, sizeof(Boolean), XtOffset(AppData*, landscape),   XtRImmediate, (XtPointer)False},
{ "popup",        "Popup",         XtRBoolean, sizeof(Boolean), XtOffset(AppData*, popup),       XtRImmediate, (XtPointer)False},
{ "popupTime",    "PopupTime",     XtRInt,     sizeof(int),     XtOffset(AppData*, popup_time),  XtRImmediate, (XtPointer)10},
{ "showNumber",   "ShowNumber",    XtRBoolean, sizeof(Boolean), XtOffset(AppData*, show_number), XtRImmediate, (XtPointer)False},
{ "beep",         "Beep",          XtRBoolean, sizeof(Boolean), XtOffset(AppData*, beep),        XtRImmediate, (XtPointer)True},
};


static Widget       shell;
static Window       w=0;
static GC           gc=0;
static Pixmap       pxm=0;
static GC           pxmgc=0;
static Display      *d=NULL;
static XtAppContext acr;
static XFontStruct  *fsAscii;
static XFontStruct  *fsKanji;
static XFontStruct  *fsKana;

//static Pixmap     icon, mask;
static XColor       fore, fore2, star, back, back2, color[8];
static char          *color_name[8]=
{"Black", "Red", "Green", "Yellow", "Blue", "Magenta", "Cyan", "White"};
static Atom         atom_wm_protocols, atom_wm_delete_window;

SocketStream        soc;
int                 popup_timer=0;


#define MAX_WHO 30


class Who
{
public:
  char *who[MAX_WHO];
  int num[MAX_WHO];
  int who_width[MAX_WHO];
  inline Who(void)
  {
    for (int i=0; i<MAX_WHO; i++)
      who[i]=NULL;
  }
  inline ~Who(void)
  {
    Clear();
  }
  inline void Clear(void)
  {
    for (int i=0; i<MAX_WHO; i++)
      delete_string(who[i]);
  }
  void Add(char *_who, int _num)
  {
    int i;
    for (i=0; i<MAX_WHO; i++)
    {
      if (!who[i]) break;
      if (strcmp(who[i], _who)==0) return;
    }
    if (i==MAX_WHO) return;
    who[i]=new_string(_who);
    num[i]=_num;
  }
  inline int N(void)
  {
    int n=0;
    for (int i=0; i<MAX_WHO; i++)
      if (who[i]) n++;
    return n;
  }
}who;


static int GetFontHeight(void)
{
  return max(max(fsAscii->max_bounds.ascent+fsAscii->max_bounds.descent,
                 fsKana ->max_bounds.ascent+fsKana ->max_bounds.descent),
             fsKanji->max_bounds.ascent+fsKanji->max_bounds.descent);
}


enum CharType { Null, Ascii, Kana, Kanji, Star, Color, OverwriteStart, OverwriteEnd, InvalidChar };


char *ParseString(char *c, int &char_r, CharType &chartype_r, int &width_r, int &fg, int &bg)
{
  int dummy;
  XCharStruct cs;

  char_r=0;
  chartype_r=InvalidChar;
  width_r=0;

#define returnNULL { chartype_r=Null; return NULL; }

  if (*c==0) returnNULL
  
  else if (*c=='\x1b')
  {
    c++;
    
    if (*c=='\0') returnNULL

    else if (*c=='[')
    {
      c++;
      if (*c=='m')
      {
        fg=-1;
        bg=-2;
        chartype_r=Color;
        return c+1;
      }
      int n=0;
      while (1)
      {
        if ('0'<=*c && *c<='9')
        {
          n=n*10+*c-'0';
          c++;
        }
        else if (*c==';' || *c=='m')
        {
          if      (30<=n && n<=37) fg=n;
          else if (40<=n && n<=47) bg=n;
          else if (n==7)
          {
            int tmp;
            tmp=fg;
            fg=bg;
            bg=tmp;
          }
          n=0;
          if (*c=='m')
          {
            chartype_r=Color;
            return c+1;
          }
          c++;
        }
        else return c;
      }
    }
    else if (*c=='0')
    {
      chartype_r=OverwriteStart;
      return c+1;
    }
    else if (*c=='1')
    {
      chartype_r=OverwriteEnd;
      return c+1;
    }
  }
  
  else if (*c>0)
  {
    char_r=*c;
    chartype_r=Ascii;
    
    XTextExtents(fsAscii, c, 1, &dummy, &dummy, &dummy, &cs);
    width_r=cs.width;
    
    return c+1;
  }
  
  else if (*c=='\x8e')
  {
    c++;
    if (!*c) returnNULL;
    
    char_r=*c;
    chartype_r=Kana;
    
    char k[1];
    *k=char_r;
    XTextExtents(fsKana, k, 1, &dummy, &dummy, &dummy, &cs);
    width_r=cs.width;
    
    return c+1;
  }
  
  else if ((c[0]=='\xa1' && c[1]=='\xfa') ||
           (c[0]=='\xa1' && c[1]=='\xf9'))
    chartype_r=Star;
  else
    chartype_r=Kanji;
  
  if (!*(c+1)) returnNULL;
  
  char k[2];
  k[0]=c[0]&0x7f;
  k[1]=c[1]&0x7f;
  XTextExtents16(fsKanji, (XChar2b*)k, 1, &dummy, &dummy, &dummy, &cs);
  width_r=cs.width;
  
  char_r=(k[0]<<8)|k[1];
  
  return c+2;
}  


void DrawChar(int x, int y, int char_, CharType chartype, int f)
{
  if (chartype==Ascii)
  {
    char k[1];
    *k=char_;
    XSetFont(d, pxmgc, fsAscii->fid);
    if (f) XDrawImageString(d, pxm, pxmgc, x, y, k, 1);
    else   XDrawString     (d, pxm, pxmgc, x, y, k, 1);
  }
  else if (chartype==Kana)
  {
    char k[1];
    *k=char_;
    XSetFont(d, pxmgc, fsKana->fid);
    if (f) XDrawImageString(d, pxm, pxmgc, x, y, k, 1);
    else   XDrawString     (d, pxm, pxmgc, x, y, k, 1);
  }
  else if (chartype==Kanji || chartype==Star)
  {
    char k[2];
    k[0]=char_>>8;
    k[1]=char_&0x7f;
    XSetFont(d, pxmgc, fsKanji->fid);
    if (f) XDrawImageString16(d, pxm, pxmgc, x, y, (XChar2b*)k, 1);
    else   XDrawString16     (d, pxm, pxmgc, x, y, (XChar2b*)k, 1);
  }
}


static int DrawText(int x, int y, char *str, unsigned long _fg, unsigned long _bg)
{
  int esc_fg=-1;
  int esc_bg=-2;
  unsigned long fg=_fg;
  unsigned long bg=_bg;
  if (x>=0 && y>=0)
  {
    XSetForeground(d, pxmgc, fg);
    XSetBackground(d, pxmgc, bg);
  }
  
  y+=max(max(fsAscii->max_bounds.ascent,
             fsKanji->max_bounds.ascent),
         fsKana->max_bounds.ascent);
  
  int width=0;
  int overwrite_width=0;
  int if_overwrite=0;
  
  while (1)
  {
    int char_;
    CharType chartype_;
    int width_;
    str=ParseString(str, char_, chartype_, width_, esc_fg, esc_bg);
    
    switch (chartype_)
    {
    case Null:
      return width;
    case Star:
      if (x>=0 && y>=0)
        XSetForeground(d, pxmgc, star.pixel);
    case Ascii:
    case Kana:
    case Kanji:
      if (x>=0 && y>=0)
        DrawChar(x+width, y, char_, chartype_, (if_overwrite<=1));
      if (if_overwrite)
      {
        if_overwrite=2;
        overwrite_width=max(overwrite_width, width_);
      }
      else width+=width_;
      if (x>=0 && y>=0)
        XSetForeground(d, pxmgc, fg);
      break;
    case Color:
      if (x>=0 && y>=0)
      {
        if (esc_fg>0) XSetForeground(d, pxmgc, fg=color[esc_fg%10%8].pixel);
        else if (esc_fg==-1) XSetForeground(d, pxmgc, fg=_fg);
        else if (esc_fg==-2) XSetForeground(d, pxmgc, fg=_bg);
        if (esc_bg>0) XSetBackground(d, pxmgc, bg=color[esc_bg%10%8].pixel);
        else if (esc_bg==-1) XSetBackground(d, pxmgc, bg=_fg);
        else if (esc_bg==-2) XSetBackground(d, pxmgc, bg=_bg);
      }
      break;
    case OverwriteStart:
      overwrite_width=0;
      if_overwrite=1;
      break;
    case OverwriteEnd:
      width+=overwrite_width;
      overwrite_width=0;
      if_overwrite=0;
      break;
    case InvalidChar:
      break;
    }
  }
}


static int GetWidth(char *str)
{
  return DrawText(-1, -1, str, 0, 0);
}


int width=1;
int height=1;


static void calc_window_size(void)
{
  if (app_data.landscape)
  {
    height=GetFontHeight()+12+((app_data.show_number)?2+GetFontHeight():0);
    width=0;
    for (int i=0; i<MAX_WHO; i++)
      if (who.who[i])
      {
        who.who_width[i]=GetWidth(who.who[i])+6;
        width+=who.who_width[i];
      }
    if (!width) width=1;
  }
  else
  {
    who.who_width[0]=GetFontHeight()+2;
    height=who.who_width[0]*who.N();
    if (!height) height=1;
    width=10;
    int ww;
    for (int i=0; i<MAX_WHO; i++)
      if (who.who[i])
      {
        ww=GetWidth(who.who[i])+2+((app_data.show_number)?4+GetWidth(ULto_string(who.num[i])):0);
        if (width<ww) width=ww;
      }
    width+=10;
  }
}


static void resize(void)
{
  if (pxm)   XFreePixmap(d, pxm);
  if (pxmgc) XFreeGC(d, pxmgc);
  calc_window_size();
  pxm=XCreatePixmap(d, w, width, height, DefaultDepth(d, 0));
  pxmgc=XCreateGC(d, pxm, 0, 0);
  
  if (app_data.landscape)
  {
    int x=0;
    for (int i=0; i<MAX_WHO; i++)
      if (who.who[i])
      {
        int ww=GetWidth(who.who[i]);
        XSetForeground(d, pxmgc, ((i%2)?back:back2).pixel);
        XFillRectangle(d, pxm, pxmgc, x, 0, ww+6, height);
        DrawText(x+3, 6, who.who[i], fore.pixel, ((i%2)?back:back2).pixel);
        if (app_data.show_number)
        {
          int www=GetWidth(ULto_string(who.num[i]));
          int xx=x+3+(ww-www)/2;
          DrawText(xx, 6+2+GetFontHeight(), ULto_string(who.num[i]), fore2.pixel, ((i%2)?back:back2).pixel);
        }
        x+=ww+6;
      }
  }
  else
  {
    int y=0;
    for (int i=0; i<MAX_WHO; i++)
      if (who.who[i])
      {
        XSetForeground(d, pxmgc, ((i%2)?back:back2).pixel);
        XFillRectangle(d, pxm, pxmgc, 0, y, width, GetFontHeight()+2);
        if (app_data.show_number)
        {
          int www=GetWidth(ULto_string(who.num[i]));
          DrawText(      5,     y+1,             who.who[i] , fore .pixel, ((i%2)?back:back2).pixel);
          DrawText(width-5-www, y+1, ULto_string(who.num[i]), fore2.pixel, ((i%2)?back:back2).pixel);
        }
        else
          DrawText((width-GetWidth(who.who[i]))/2, y+1, who.who[i], fore.pixel, ((i%2)?back:back2).pixel);
        y+=GetFontHeight()+2;
      }
  }
}


static void get_window_size(const Window w, unsigned int *width_r, unsigned int *height_r)
{
  Window root;
  int x, y;
  unsigned int border, depth;
  XGetGeometry(d, w, &root, &x, &y, width_r, height_r, &border, &depth);
}


static void redraw(Widget widget, XEvent *e, String *params, Cardinal *num_params)
{
  if (!pxm) resize();
  unsigned int _height, _width;
  get_window_size(w, &_width, &_height);
  if (_width!=width || _height!=height || e==NULL)
  {
    XResizeWindow(d, w, width, height);
    //XtResizeWidget(shell, width, height, 0);
    XtVaSetValues
      (shell,
       XtNwidth,     width,
       XtNheight,    height,
       XtNmaxWidth,  width,
       XtNmaxHeight, height,
       XtNminWidth,  width,
       XtNminHeight, height,
       NULL);
    XCopyArea(d, pxm, w, gc, 0, 0, width, height, 0, 0);
  }
  else
    XCopyArea(d, pxm, w, gc,
              e->xexpose.x,     e->xexpose.y,
              e->xexpose.width, e->xexpose.height,
              e->xexpose.x,     e->xexpose.y);
}


static void close_window(Widget widget, XEvent *e, String *params, Cardinal *num_params)
{
  if (e->type==ClientMessage &&
      e->xclient.message_type==atom_wm_protocols &&
      e->xclient.data.l[0]==atom_wm_delete_window)
    exit(0);
}


static void toggle_show_number(Widget widget, XEvent *e, String *params, Cardinal *num_params)
{
  app_data.show_number=!app_data.show_number;
  resize();
  redraw(NULL, NULL, NULL, NULL);
}


static void toggle_landscape(Widget widget, XEvent *e, String *params, Cardinal *num_params)
{
  app_data.landscape=!app_data.landscape;
  resize();
  redraw(NULL, NULL, NULL, NULL);
}


static void ping(Widget widget, XEvent *e, String *params, Cardinal *num_params)
{
  if (e->type==ButtonPress || e->type==ButtonRelease)
  {
    if (app_data.landscape)
    {
      int x=e->xbutton.x;
      int i;
      for (i=0; i<MAX_WHO; i++)
      {
        if (who.who[i])
        {
          x-=who.who_width[i];
          if (x<=0) break;
        }
      }
      if (i!=MAX_WHO)
      {
        char *my_name=GetMyName();
        if (my_name)
        {
          char buf[BUFSIZE];
          sprintf(buf, "^[%s] ping %s\n", my_name, who.who[i]);
          soc.Puts(soc.SocketFD(), buf);
        }
      }
    }
    else
    {
      int y=e->xbutton.y/who.who_width[0];
      int i;
      for (i=0; i<MAX_WHO; i++)
      {
        if (y==0 && who.who[i]) break;
        if (who.who[i]) y--;
      }
      if (i!=MAX_WHO)
      {
        char *my_name=GetMyName();
        if (my_name)
        {
          char buf[BUFSIZE];
          sprintf(buf, "^[%s] ping %s\n", my_name, who.who[i]);
          soc.Puts(soc.SocketFD(), buf);
        }
      }
    }
  }
}


static void quit(Widget widget, XEvent *e, String *params, Cardinal *num_params)
{
  exit(0);
}


static XtActionsRec actions[]=
{
{"quit",               quit},
{"redraw",             redraw},
{"toggle_show_number", toggle_show_number},
{"toggle_landscape",   toggle_landscape},
{"close",              close_window},
{"ping",               ping},
};


static String translation=
"<ClientMessage>:   close()\n"
"<ConfigureNotify>: redraw()\n"
"<Key>s:            toggle_show_number()\n"
"<Key>n:            toggle_show_number()\n"
"<Key>t:            toggle_show_number()\n"
"<Btn1Down>:        toggle_show_number()\n"
"<Key>l:            toggle_landscape()\n"
"<Btn2Down>:        toggle_landscape()\n"
"<Btn3Down>:        ping()\n"
"<Key>q:            quit()\n"
"<Key>Escape:       quit()\n"
"<Expose>:          redraw()\n";


static void read_data(int is_redraw=True)
{
  static f;
  
  int i;
  while ((i=soc.Select(0))>=0)
  {
    if (0<=i && i<MAX_FD)
    {
      char buf[BUFSIZE];
      soc.Gets(soc.SocketFD(), buf, BUFSIZE, 100);
      remove_newline(buf);
      if (strncmp(buf, "## __", 5)==0)
      {
        f=who.N();
        who.Clear();
      }
      else if (strncmp(buf, "## --", 5)==0)
      {
        if (is_redraw)
        {
          resize();
          redraw(NULL, NULL, NULL, NULL);
          if (f<who.N() && app_data.beep) XBell(d, 0);
          XMapWindow(d, w);
          popup_timer=app_data.popup_time;
        }
      }
      else
      {
        int num=atoi(buf);
        char *name=strchr(buf, ' ');
#ifdef OLD_FORMAT
# if 0
        char *a[]={NULL, NULL, name};
        do
        {
          a[0]=a[1];
          a[1]=a[2];
          a[2]=strchr(a[2]+1, '@');
        } while (a[2]);
        if (name && a[0])
        {
          *a[0]='\0';
          who.Add(name+1, num);
        }
# else
				if (!name) continue;
				name++;
				char *p;
				p = strrchr(name, '(');
				if (!p) continue;
				if (p - 2 <= name) continue;
				if (*--p != ' ') continue;
				if (*(p-1) == '\r') p--;
				*p = 0;
				if (p - 1 <= name) 	continue;
				if (*(p-1) == ']') { //[
					p = strrchr (name, '['); //[
					if (!p)
						continue;
					if (p == name) continue;
					if (*--p != ' ')
						continue;
					*p = 0;
				}
				if (*(p-1) == '>') { //<
					p = strstr (name, " <"); //>
					if (!p)
						continue;
					*p = 0;
				}
				p = strrchr (name, '@');
				if (p) *p = 0;
				who.Add(name, num);
#endif
#else /* NEW_FORMAT */
				if (!name) continue;
				if (strlen(name) < 30) continue;
				name++;
				name[28] = 0;
				for (int i = 27; i > 0 ; i--)
					if (name[i] == '@') {
						name[i] = 0;
						break;
					}
				who.Add(name,num);
#endif
      }
    }
    else if (MAX_FD*2<=i && i<MAX_FD*3)
      quit(NULL, NULL, NULL, NULL);
  }
}


static void timer_event(XtPointer client_data, XtIntervalId *id)
{
  if (app_data.popup)
    if (popup_timer>0)
    {
      popup_timer--;
      if (!popup_timer)
	XIconifyWindow(d, w, 0);
    }
  read_data();
  XtAppAddTimeOut(acr, 1000, timer_event, (XtPointer)NULL);
}


int main(int argc, char *argv[])
{
  shell=XtVaAppInitialize
    (&acr, "XItalkBiff", options, XtNumber(options),
     &argc, argv, default_resources, NULL);
  d=XtDisplay(shell);
  XtAppAddActions(acr, actions, XtNumber(actions));
  XtGetApplicationResources(shell, XtPointer(&app_data), resources, XtNumber(resources), NULL, 0);
  XtAugmentTranslations(shell, XtParseTranslationTable(translation));
  
  // socket
  char *server=SocketStream::GetServer(app_data.italkpipe, "localhost");
  US port=SocketStream::GetPort(app_data.italkpipe, 20875);
  if (app_data.help)
  {
    fprintf(stderr,
	    "xitalkbiff 0.09 - GANA\n"
	    "usage: xitalkbiff [options ...]\n"
	    "       -i <host[:port]>, -fn <ascii-font>, -fk <kanji-font>, -fr <kana-font>, \n"
	    "       -fg <color>, -fg2 <color>, -star <color>, -bg <color>, -bg2 <color>,\n"
	    "       -h, -l, -nl, -p, -pt <popuptime>, -n, -nn, -iconic, etc.\n");
    return 1;
  }
  if (soc.Init(SOCKET_STREAM_CLIENT, server, port, True, 100))
    return 1;

   /*
   icon=XCreateBitmapFromData(d, RootWindow(d, 0), (char *)icon_bits, icon_width, icon_height);
   mask=XCreateBitmapFromData(d, RootWindow(d, 0), (char *)mask_bits, mask_width, mask_height);
   XtVaSetValues(shell, XtNiconPixmap, icon, XtNiconMask, mask, NULL);
   */
  
  // font
  if (!(fsAscii=XLoadQueryFont(d, app_data.fontAscii)))
  {
    fprintf(stderr, "Failed to load ascii font.\n");
    return (1);
  }
  if (!(fsKana =XLoadQueryFont(d, app_data.fontKana)))
  {
    fprintf(stderr, "Failed to load kana font.\n");
    fprintf(stderr, "font error\n");
    return (1);
  }
  if (!(fsKanji=XLoadQueryFont(d, app_data.fontKanji)))
  {
    fprintf(stderr, "Failed to load kanji font.\n");
    return (1);
  }

  
  // initial data
  read_data(False);
  calc_window_size();
  XtVaSetValues
    (shell,
     XtNwidth,     width,
     XtNheight,    height,
     XtNmaxWidth,  width,
     XtNmaxHeight, height,
     XtNminWidth,  width,
     XtNminHeight, height,
     XtNinput,     True,
     NULL);
  
  // realize
  XtVaSetValues(shell, XtNinput, True, NULL);
  XtRealizeWidget(shell);
  w=XtWindow(shell);
  atom_wm_protocols    =XInternAtom(d, "WM_PROTOCOLS",     False);
  atom_wm_delete_window=XInternAtom(d, "WM_DELETE_WINDOW", False);
  XSetWMProtocols(d, w, &atom_wm_delete_window, 1);
  gc=XCreateGC(d, w, 0, 0);
  
  // color
  XColor dummy;
  XAllocNamedColor(d, DefaultColormap(d, 0), app_data.foreground,  &fore,  &dummy);
  XSetForeground(d, gc, fore.pixel);
  XAllocNamedColor(d, DefaultColormap(d, 0), app_data.foreground2, &fore2, &dummy);
  XAllocNamedColor(d, DefaultColormap(d, 0), app_data.background,  &back,  &dummy);
  XAllocNamedColor(d, DefaultColormap(d, 0), app_data.background2, &back2, &dummy);
  XSetBackground(d, gc, back.pixel);
  XAllocNamedColor(d, DefaultColormap(d, 0), app_data.star,        &star,  &dummy);
  for (int i=0; i<8; i++)
    XAllocNamedColor(d, DefaultColormap(d, 0), color_name[i],   &color[i], &dummy);
  
  XtAppAddTimeOut(acr, 1000, timer_event, (XtPointer)NULL);
  
  // signal
  signal(SIGTERM, (void (*)(int))quit);
  signal(SIGINT, (void (*)(int))quit);
  
  // main loop
  XtAppMainLoop(acr);
  return 0;
}
